#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>

#define ll long long

using namespace std;

template <class t = uint_fast32_t>
t next() { t x; cin >> x; return x; }

inline uint_fast32_t to_mass(uint_fast32_t s, uint_fast32_t m, vector<uint_fast32_t>& arr)
{
	uint_fast32_t sum = 0;

	for (uint_fast32_t i = 0; i < 27; i++)
	{
		if (s & (1 << i))
		{
			sum += arr[i];
		}
	}

	return sum % m;
}

int main()
{
	uint_fast32_t n = next(), m = next();
	vector<uint_fast32_t> arr(n);
	set<uint_fast32_t>* tmp = new set<uint_fast32_t>();

	for (uint_fast32_t i = 0; i < n; i++)
	{
		uint_fast32_t x = next() % m;
		arr[i] = x;
		tmp->insert(x);
	}

	if (tmp->size() < n)
	{
		for (uint_fast32_t i = 0; i < n; i++)
		{
			for (uint_fast32_t j = i + 1; j < n; j++)
			{
				if (arr[i] == arr[j])
					cout << "1\n" << i + 1 << "\n" << "1\n" << j + 1 << '\n';
			}
		}

		return 0;
	}

	delete tmp;

	unordered_map<uint_fast32_t, vector<uint_fast32_t>> mask(m/2);

	for (uint_fast32_t s = 0; s < (1 << n); s++)
	{
		uint_fast32_t mass = to_mass(s, m, arr);

		for (uint_fast32_t s_old : mask[mass])
		{
			if ((s & s_old) == 0)
			{
				vector<uint_fast32_t> a, b;

				for (uint_fast32_t i = 0; i < 27; i++)
				{
					if (s & (1 << i))
						a.push_back(i + 1);
					if (s_old & (1 << i))
						b.push_back(i + 1);
				}

				cout << a.size() << '\n';
				for (uint_fast32_t i : a) cout << i << ' ';
				cout << '\n' << b.size() << '\n';
				for (uint_fast32_t i : b) cout << i << ' ';

				return 0;
			}

		}

		mask[mass].push_back(s);
		
		if (mask[mass].size() > 10)
		{
			mask.erase(mass);
		}
	}

	cout << "-1\n";
	return 0;
}