#include <bits/stdc++.h>
#define all(a) (a).begin(), (a).end()
#define rep(i, n) for (int i = 0; i < (n); i++) 

using namespace std;

typedef long long ll;

const int N = 3e5 + 228;
const int MEM = 2e8;

char c[MEM];

int ptr = 0;

void *operator new(size_t n) {
	ptr += n;
	return (void*) (c + ptr - n);
}

void operator delete(void *) {

}

mt19937 rnd(time(0));

struct treap {
	treap *l, *r, *par;
	int sz;
	int y;
	treap() {
		sz = 1;
		y = rnd();
		par = 0;
		l = r = 0;
	}
	treap(treap *p) {
		sz = 1;
		y = rnd();
		par = p;
		l = r = 0;
	}
};

int siz(treap *t) {
	if (!t) return 0;
	return t->sz;
}

void recalc(treap *t) {
	if (!t) return;
	t->sz = 1 + siz(t->l) + siz(t->r);
}

int get_id(treap *t) {
	int sum = siz(t->l);
	while (t->par) {
		if (t->par->l == t) {
			t = t->par;
		} else {
			sum += siz(t->par->l) + 1;
			t = t->par;
		}
	}
	return sum;
}

void set_l(treap *t, treap *x) {
	if (x)
		x->par = t;
	t->l = x;
	recalc(t);
}

void set_r(treap *t, treap *x) {
	if (x)
		x->par = t;
	t->r = x;
	recalc(t);
}

pair <treap *, treap *> split(treap *t, int k) {
	if (!t) return {0, 0};
	t->par = 0;
	if (siz(t->l) >= k) {
		auto a = split(t->l, k);
		set_l(t, a.second);
		return {a.first, t};
	} else {
		auto a = split(t->r, k - siz(t->l) - 1);
		set_r(t, a.first);
		return {t, a.second};
	}
}

treap *merge(treap *a, treap *b) {
	if (!a) return b;
	if (!b) return a;
	a->par = 0, b->par = 0;
	if (a->y > b->y) {
		set_r(a, merge(a->r, b));
		return a;
	} else {
		set_l(b, merge(a, b->l));
		return b;
	}
}

treap *get_root(treap *t) {
	while (t->par) t = t->par;
	return t;
}

set <int> g[N];
map <pair <int, int>, treap*> st;

pair <int, int> any_edge(int v) {
	assert(!g[v].empty());
	return make_pair(v, *g[v].begin());
}

bool is_connected(int a, int b) {
	if (a == b) {
		return true;
	}
	if (g[a].empty() || g[b].empty()) return false;
	return get_root(st[any_edge(a)]) == get_root(st[any_edge(b)]);
}

void make_first(treap *t) {
	int id = get_id(t);
	auto a = split(get_root(t), id);
	merge(a.second, a.first);
}

void make_last(treap *t) {
	int id = get_id(t);
	auto a = split(get_root(t), id + 1);
	merge(a.second, a.first);
}

void link(int u, int v) {

	st[{u, v}] = new treap();
	st[{v, u}] = new treap();
	if (g[v].empty()) swap(u, v);
	if (g[u].empty()) {
		if (g[v].empty()) {
			merge(st[{u, v}], st[{v, u}]);
		} else {
			auto x = any_edge(v);
			make_first(st[x]);
			merge(st[{u, v}], get_root(st[x]));
			merge(get_root(st[x]), st[{v, u}]);
		}
	} else {
		pair <int, int> x, y;
		{
			x = any_edge(u);
			swap(x.first, x.second);
			make_last(st[x]);
		}
		{
			y = any_edge(v);
			make_first(st[y]);
		}
		merge(get_root(st[x]), st[{u, v}]);
		merge(get_root(st[x]), get_root(st[y]));
		merge(get_root(st[x]), st[{v, u}]);
	}
	g[u].insert(v);
	g[v].insert(u);
}

void cut(int u, int v) {
	g[u].erase(v);
	g[v].erase(u);
	auto x = make_pair(u, v);
	make_first(st[x]);
	auto a = split(get_root(st[x]), 1);
	auto y = make_pair(v, u);
	int ret = get_id(st[y]);
	auto b = split(a.second, ret);
	split(b.second, 1);
	delete st[x];
	delete st[y];
	st[x] = st[y] = 0;
}

int main() {
#ifdef ONPC
	freopen("a.in", "r", stdin);
#endif
	int n = 2000;
//	cin >> n;
	vector <int> a(n);
	vector <int> b;
	for (int i = 0; i < n; i++) {
		a[i] = rnd() % n + 1;
		//cin >> a[i];
		b.push_back(a[i]);
	}
	auto value = a;
	sort(b.begin(), b.end());
	b.resize(unique(b.begin(), b.end()) - b.begin());
	for (int i = 0; i < n; i++) {
		a[i] = lower_bound(b.begin(), b.end(), a[i]) - b.begin();
	}
	vector <int> ok(n + 2);
	for (int chet = 0; chet < 2; chet++) {
		vector <pair <int, int> > edges;
		for (int i = chet; i + 1 < n; i += 2) {
			edges.push_back({a[i], a[i + 1]});
		}
		int j = -1;
		for (int i = 0; i < (int) edges.size(); i++) {
			j = max(j, i - 1);
			while (j + 1 < (int) edges.size()) {
				if (is_connected(edges[j + 1].first, edges[j + 1].second)) {
					break;
				}
				link(edges[j + 1].first, edges[j + 1].second);
				j++;
			}
			ok[2 * i + chet] = 2 * j + chet + 1;
			if (j >= i) {
				cut(edges[i].first, edges[i].second);
			}
		}
	}
	ll ans = 0;
	vector <int> dp(n + 1);
	for (int i = n - 1; i >= 0; i--) {
		if (value[i] == 0 || ok[i + 1] >= i + 2 * value[i]) {
			dp[i] = dp[i + 2 * value[i] + 1] + 1;
		} else {
			dp[i] = 0;
		}
		ans += dp[i];
	}
	cout << ans << endl;
//	cout << clock() / (double) CLOCKS_PER_SEC << endl;
}
