#include <iostream>
#include <cstdio>
#include <vector>
#include <string>

using namespace std;

vector<vector<int>> friends;
vector<int> parent;
vector<int> mass;
vector<int> dp;

int getParent( int i )
{
    int root, leaf = i, j;
    for (; i != parent[i]; i = parent[i]);
    root = i, i = leaf, j = parent[i];
    while (j != root)
    {
        parent[i] = root;
        i = j;
        j = parent[i];
    }
    return root;
}

void link( int i, int j )
{
    j = getParent(j);
    i = getParent(i);
    if (mass[i] > mass[j])
        parent[j] = i, mass[j] += mass[i];
    else
        parent[i] = j, mass[i] += mass[j];
}

bool lol( int i, int j )
{
    return getParent(i) == getParent(j);
}

int query( int i )
{
    int res = 0, c = 0, m = 0;
    vector<int> g = friends[i];
    friends[i].clear();
    for (int j : g)
        if (lol(i, j))
            res++;
        else
            c++;
    friends[i] = vector<int>(c);
    for (int j : g)
        if (!lol(i, j))
            friends[i][m++] = j;
    dp[i] += res;
    return dp[i];
}

int main( int argc, char* argv[] )
{
    int n, m, k, q, a, b, res;
    char key;
    cin >> n >> m >> k;
    parent = vector<int>(n);
    friends = vector<vector<int>>(n);
    mass = vector<int>(n, 1);
    dp = vector<int> (n, 0);
    for (int i = 0; i < n; i++)
        parent[i] = i;
    for (int i = 0; i < m; i++)
        cin >> a >> b, friends[a - 1].push_back(b - 1), friends[b - 1].push_back(a - 1);
    for (int i = 0; i < k; i++)
        cin >> a >> b, link(a - 1, b - 1);
    cin >> q;
    for (int i = 0; i < q; i++)
    {
        cin >> key;
        if (key == 'T')
            cin >> a >> b, link(a - 1, b - 1);
        else if (key == 'F')
        {
            cin >> a >> b;
            if (lol(a - 1, b - 1))
                dp[a - 1]++, dp[b - 1]++;
            else
                friends[a - 1].push_back(b - 1), friends[b - 1].push_back(a - 1);
        }
        else
            cin >> a, cout << query(a - 1) << '\n';
    }
    return 0;
}


