#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <iomanip>
#include <map>
#include <set>
#include <cmath>
#include <random>
#include <unordered_set>
#include <conio.h>
#define UNDEF -1;

using namespace std;


typedef long long int ll;

struct edge {
	int u;
	int v;
	int cost;
	edge(int a, int b, int c) {
		u = a;
		v = b;
		cost = c;
	}
};

struct event {
	int x;
	int type;
	int num;
	event(int x, int type, int num) : x(x), type(type), num(num) {}
};

int n, m, k, q;

vector<int> p(n), r(n);

int root(int a) {
	if (p[a] == -1)
		return a;
	else {
		p[a] = root(p[a]);
		return p[a];
	}
}

bool find(int a, int b) {
	if (root(a) == root(b))
		return 1;
	else return 0;
}

void Union(int a, int b) {
	int x = root(a);
	int y = root(b);
	if (x != y) {
		if (r[x] < r[y])
			p[x] = y;
		else if (r[x] > r[y])
			p[y] = x;
		else {
			p[x] = y;
			r[y]++;
		}
	}
}

int main() {
	cin >> n >> m >> k;
	p.assign(n, -1);
	r.assign(n, 0);

	vector<vector<int>> Friend(n);
	for (int i = 0; i < m; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		Friend[a].push_back(b);
		Friend[b].push_back(a);
	}

	for (int i = 0; i < k; i++) {
		int a, b;
		cin >> a >> b;
		a--;
		b--;
		Union(a, b);
	}
	
	cin >> q;
	for (int i = 0; i < q; i++) {
		char c;
		cin >> c;
		if (c == 'T') {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			Union(a, b);
		}
		else if (c == 'F') {
			int a, b;
			cin >> a >> b;
			a--;
			b--;
			Friend[a].push_back(b);
			Friend[b].push_back(a);
		}
		else if (c == '?') {
			int a, ans = 0;
			cin >> a;
			a--;
			for (int j = 0; j < Friend[a].size(); j++) {
				if (find(a, Friend[a][j]))
					ans++;
			}
			cout << ans << endl;
		}
	}

	return 0;
}


