#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

#define int long long

const int N = 10;

int x, y, z;
int a, b, c;
int t[3];
int d;
int k, i, l, j;
struct Edge { int v, u, w; };
vector<Edge> g[10];

int f(int q, int w, int e) {
	if (q < w) {
		swap(q, w);
	}
	return (q - w) * t[e];
}

void add_edge(int v, int u, int w) {
	g[v].push_back({ v, u, w });
	g[u].push_back({ u, v, w });
}

const int INF = 4e18;

int dist[N][N];

void floyd() {
	for (int v = 0; v < N; ++v) {
		for (int u = 0; u < N; ++u) {
			if (v != u) {
				dist[v][u] = INF;
			}
		}
	}
	for (int v = 0; v < N; ++v) {
		for (Edge e : g[v]) {
			dist[v][e.u] = min(dist[v][e.u], e.w);
		}
	}
	for (int t = 0; t < N; ++t) {
		for (int v = 0; v < N; ++v) {
			for (int u = 0; u < N; ++u) {
				if (dist[v][t] != INF && dist[t][u] != INF && dist[v][u] - dist[t][u] > dist[v][t]) {
					dist[v][u] = dist[v][t] + dist[t][u];
				}
			}
		}
	}
}

signed main() {
	ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
	cin >> x >> y >> z >> a >> b >> c >> t[0] >> t[1] >> t[2] >> d >> k >> i >> l >> j;
	--l; --k;
	/*
	0 : start
	1 : finish
	2 : a     on line0
	3 : a + 1 on line0
	4 : b     on line1
	5 : b + 1 on line1
	6 : c     on line2
	7 : c + 1 on line2
	*/
	if (k == 0) {
		add_edge(0, 2, f(i, a, 0));
		add_edge(0, 3, f(i, a + 1, 0));
		if (i == a) {
			add_edge(0, 5, 0);
		}
		else if (i == a + 1) {
			add_edge(0, 6, 0);
		}
	}
	else if (k == 1) {
		add_edge(0, 4, f(i, b, 1));
		add_edge(0, 5, f(i, b + 1, 1));
		if (i == b) {
			add_edge(0, 7, 0);
		}
		else if (i == b + 1) {
			add_edge(0, 2, 0);
		}
	}
	else if (k == 2) {
		add_edge(0, 6, f(i, c, 2));
		add_edge(0, 7, f(i, c + 1, 2));
		if (i == c) {
			add_edge(0, 3, 0);
		}
		else if (i == c + 1) {
			add_edge(0, 4, 0);
		}
	}
	if (l == 0) {
		add_edge(1, 2, f(j, a, 0));
		add_edge(1, 3, f(j, a + 1, 0));
		if (j == a) {
			add_edge(1, 5, 0);
		}
		else if (j == a + 1) {
			add_edge(1, 6, 0);
		}
	}
	else if (l == 1) {
		add_edge(1, 4, f(j, b, 1));
		add_edge(1, 5, f(j, b + 1, 1));
		if (j == b) {
			add_edge(1, 7, 0);
		}
		else if (j == b + 1) {
			add_edge(1, 2, 0);
		}
	}
	else if (l == 2) {
		add_edge(1, 6, f(j, c, 2));
		add_edge(1, 7, f(j, c + 1, 2));
		if (j == c) {
			add_edge(1, 3, 0);
		}
		else if (j == c + 1) {
			add_edge(1, 4, 0);
		}
	}
	add_edge(2, 3, t[0]);
	add_edge(4, 5, t[1]);
	add_edge(6, 7, t[2]);
	add_edge(2, 5, d);
	add_edge(4, 7, d);
	add_edge(6, 3, d);
	floyd();
	cout << dist[0][1] << '\n';
	return 0;
}