def read_ints():
    return [int(x) for x in input().split()]

def add_edge_friendship(g, x, y):
    g[x][y] = True
    g[y][x] = True

def add_edge_races(g, x, y):
    g[x].append(y)
    g[y].append(x)

def read_command():
    i = input().split()
    if len(i) < 3: return i[0], int(i[1]), None
    else: return i[0], int(i[1]), int(i[2])

reach_answer = 0

def reach_amount_dfs(target, current, vst, races, friendship):
    global reach_answer
    if vst[current]: return

    if friendship[target][current]: reach_answer += 1
    vst[current] = True
    for v in races[current]:
        reach_amount_dfs(target, v, vst, races, friendship)

def reach_amount(target, races, friendship):
    global reach_answer
    reach_answer = 0
    vst = [False for i in range(len(races))]
    reach_amount_dfs(target, target, vst, races, friendship)
    return reach_answer

n, m, k = read_ints()
races = [[] for j in range(n)]
friendship = [[False for i in range(n)] for j in range(n)]

for i in range(m):
    a, b = read_ints()
    add_edge_friendship(friendship, a-1, b-1)
for i in range(k):
    a, b = read_ints()
    add_edge_races(races, a-1, b-1)

q = int(input())
for i in range(q):
    cmd, arg1, arg2 = read_command()
    if cmd == "T": add_edge_races(races, arg1-1, arg2-1)
    elif cmd == "F": add_edge_friendship(friendship, arg1-1, arg2-1)
    elif cmd == "?": print(reach_amount(arg1-1, races, friendship))