#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

void print_masked(vector<unsigned long long> const &a, unsigned int mask) {
    vector<unsigned int> res;
    for (unsigned int bit = 0; bit < a.size(); bit++) {
        if ((mask >> bit) & 1u) {
            res.push_back(bit + 1);
        }
    }
    cout << res.size() << '\n';
    for (unsigned int t : res) {
        cout << t << ' ';
    }
    cout << '\n';
}

int main() {

#ifdef LOCAL
    freopen("inf", "r", stdin);
    freopen("ouf", "w", stdout);
#endif

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    unsigned int n, m;
    cin >> n >> m;
    vector<unsigned long long> a(n);
    for (unsigned int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<pair<unsigned int, unsigned int>> fit(m, {0, 0});
    for (unsigned int mask = 1u; mask < (1u << n); mask++) {
        unsigned int cnt = 0;
        unsigned long long sum = 0;
        for (unsigned int bit = 0; bit < n; bit++) {
            if ((mask >> bit) & 1u) {
                cnt++;
                sum += a[bit];
            }
        }
        unsigned int mod = static_cast<unsigned int>(sum % m);
        if (mod == 0 || fit[mod].first) {
            assert((mask & fit[mod].second) == 0);

            print_masked(a, mask);
            print_masked(a, fit[mod].second);

            return 0;
        } else {
            fit[mod] = {cnt, mask};
        }
    }

    cout << "-1\n";

}
