// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }


void solve() {
	int n;
	cin >> n;
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
	}

	int ans = 0;

	for (int i = 0; i < n; ++i) {
		int pos = i;
		while (pos < n) {
			int en = arr[pos++];
			if (pos + en * 2 > n) {
				break;
			}
			int vn = en * 2;
			bool ok = true;
			vector<vector<int>> graph(vn);
			map<int, int> inds;
			auto get_ind = [&](int v) {
				if (!inds.count(v)) {
					int tmp = szof(inds);
					inds[v] = tmp;
				}
				return inds[v];
			};
			for (int j = 0; j < en; ++j, pos += 2) {
				int a = get_ind(arr[pos]), b = get_ind(arr[pos + 1]);
				graph[a].push_back(b);
				graph[b].push_back(a);
			}

			vector<bool> used(n);
			function<bool(int, int)> dfs = [&](int v, int p) {
				used[v] = true;
				for (int to : graph[v]) {
					if (to != p) {
						if (used[to] || dfs(to, v)) {
							return true;
						}
					}
				}
				return false;
			};

			for (int j = 0; j < vn; ++j) {
				if (!used[j]) {
					if (dfs(j, -1)) {
						ok = false;
						break;
					}
				}
			}
			if (ok) {
				++ans;
			} else {
				break;
			}
		}
	}

	cout << ans << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
