// Created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;
int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;
#ifdef LOCAL
	mt19937 tw(9450189);
#else
	mt19937 tw(chrono::high_resolution_clock::now().time_since_epoch().count());
#endif
uniform_int_distribution<ll> ll_distr;
ll rnd(ll a, ll b) { return ll_distr(tw) % (b - a + 1) + a; }

struct node {
	int l, r, par, sz;
	ll y;
	node() : l(0), r(0), par(-1), sz(0) {}
	node(int) : l(0), r(0), par(-1), sz(1), y(rnd(-INFL, INFL)) {}
};

vector<node> treap;

void t_upd(int v) {
	int vl = treap[v].l;
	int vr = treap[v].r;
	treap[v].sz = treap[vl].sz + 1 + treap[vr].sz;
	treap[vl].par = treap[vr].par = v;
	treap[v].par = -1;
}

void t_merge(int vl, int vr, int& v) {
	if (vl == 0 || vr == 0) {
		v = vl + vr;
		return;
	}
	if (treap[vl].y > treap[vr].y) {
		t_merge(treap[vl].r, vr, treap[vl].r);
		v = vl;
	} else {
		t_merge(vl, treap[vr].l, treap[vr].l);
		v = vr;
	}
	t_upd(v);
}

void t_split(int v, int& vl, int& vr, int amount) {
	if (!v) {
		vl = vr = 0;
		return;
	}
	if (treap[treap[v].l].sz >= amount) {
		t_split(treap[v].l, vl, treap[v].l, amount);
		vr = v;
		t_upd(vr);
	} else {
		t_split(treap[v].r, treap[v].r, vr, amount - treap[treap[v].l].sz - 1);
		vl = v;
		t_upd(vl);
	}
}

pii get_root(int v) {
	int pos = treap[treap[v].l].sz;
	while (treap[v].par != -1) {
		int p = treap[v].par;
		if (treap[p].r == v) {
			pos += treap[treap[p].l].sz + 1;
		}
		v = p;
	}
	return {v, pos};
}

void solve() {
	treap.push_back(node());
	int n;
	cin >> n;
	map<int, int> inds;
	auto get_ind = [&](int v) {
		if (!inds.count(v)) {
			int tmp = szof(inds);
			inds[v] = tmp;
		}
		return inds[v];
	};
	vector<int> arr;
	for (int i = 0; i < n; ++i) {
		int num;
		cin >> num;
		arr.push_back(num);
		get_ind(num);
	}

	vector<bool> can_start(n);
	vector<pair<pii, int>> reqs;
	for (int i = 0; i < n; ++i) {
		if (arr[i] == 0) {
			can_start[i] = true;
		} else if (i + 1 + arr[i] * 2 <= n) {
			reqs.push_back({{i + 1, i + 1 + arr[i] * 2}, i});
		}
	}

	vector<int> free_nodes;
	auto add_node = [&]() {
		if (szof(free_nodes)) {
			int ret = free_nodes.back();
			free_nodes.pop_back();
			return ret;
		}
		treap.push_back(node(1));
		return szof(treap) - 1;
	};

	vector<int> node_nodes;
	for (int i = 0; i < szof(inds); ++i) {
		node_nodes.push_back(add_node());
	}

	map<pii, int> edge_nodes;

	auto add_edge = [&](int u, int v) {
		auto [ru, posu] = get_root(node_nodes[u]);
		auto [rv, posv] = get_root(node_nodes[v]);
		if (ru == rv) {
			return false;
		}

		if (posu) {
			int l, r;
			t_split(ru, l, r, posu);
			t_merge(r, l, ru);
		}

		if (posv) {
			int l, r;
			t_split(rv, l, r, posv);
			t_merge(r, l, rv);
		}

		int uv = add_node();
		int vu = add_node();
		edge_nodes[{u, v}] = uv;
		edge_nodes[{v, u}] = vu;

		int tmp, tmp2;
		t_merge(ru, uv, tmp);
		t_merge(rv, vu, tmp2);
		t_merge(tmp, tmp2, tmp);

		return true;
	};

	auto rem_edge = [&](int u, int v) {
		int uv = edge_nodes[{u, v}];
		int vu = edge_nodes[{v, u}];
		edge_nodes.erase({u, v});
		edge_nodes.erase({v, u});
		auto [rt, posuv] = get_root(uv);
		auto [tmp, posvu] = get_root(vu);
		int pos1 = posvu, pos2 = posuv;
		if (pos1 > pos2) {
			swap(pos1, pos2);
		}
		int l, m, r;
		t_split(rt, l, r, pos2);
		t_split(r, tmp, r, 1);
		t_split(l, l, m, pos1);
		t_split(m, tmp, m, 1);
		t_merge(r, l, r);
		free_nodes.push_back(uv);
		free_nodes.push_back(vu);
	};

	for (int from = 0; from <= 1; ++from) {
		vector<pii> edges;
		for (int i = from; i + 2 <= n; i += 2) {
			edges.push_back({get_ind(arr[i]), get_ind(arr[i + 1])});
		}

		vector<int> from_here(szof(edges));
		int cnt = 0;
		for (int i = 0; i < szof(edges); ++i) {
			while (cnt < szof(edges) && add_edge(edges[cnt].ff, edges[cnt].ss)) {
				++cnt;
			}
			from_here[i] = cnt;
			if (edges[i].ff != edges[i].ss) {
				rem_edge(edges[i].ff, edges[i].ss);
			} else {
				++cnt;
			}
		}

		for (auto p : reqs) {
			if (p.ff.ff % 2 == from) {
				can_start[p.ss] = p.ff.ss <= from + from_here[p.ff.ff / 2] * 2;
			}
		}
	}

	vector<ll> dp(n + 1);

	for (int i = 0; i < n; ++i) {
		++dp[i];
		if (can_start[i]) {
			dp[i + 1 + arr[i] * 2] += dp[i];
		}
	}

	cout << accumulate(dp.begin(), dp.end(), 0ll) - n << "\n";
}


int main() {
#ifdef LOCAL
	auto start_time = clock();
	cerr << setprecision(3) << fixed;
#endif
	cout << setprecision(15) << fixed;
	ios::sync_with_stdio(false);
	cin.tie(nullptr);

	int test_count = 1;
	// cin >> test_count;
	for (int test = 1; test <= test_count; ++test) {
		solve();
	}
	
#ifdef LOCAL
	auto end_time = clock();
	cerr << "Execution time: " << (end_time - start_time) * (int)1e3 / CLOCKS_PER_SEC << " ms\n";
#endif
}
